#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

#ifdef DEBUG 
#include <math.h>
#endif

typedef long typett;

union endianess {
  typett lungo;
  char ch[sizeof(typett)];
};

int main (void) 
{

#ifdef DEBUG 
  int i;
  union endianess marshal;
#endif  

  union endianess unione;
    
  unione.lungo = 1;

#ifdef DEBUG

  for (i=0; i<(int) sizeof (typett); ++i) {
    if (unione.ch[i] == 1)
      fprintf (stdout, "1");
    else
      fprintf (stdout, "0");
  }
  fprintf (stdout, "\n");

#endif  
    
  if (unione.ch[sizeof(typett)-1] == 1) 
    printf("big endian\n");
  else
    printf("little endian\n");

#ifdef DEBUG

  for (i=0; i<(int) sizeof (typett); ++i) 
    marshal.ch[sizeof (typett) - (i+1)] = unione.ch[i];

  fprintf (stdout, "%ld <-> %ld\n", unione.lungo, marshal.lungo);
  fprintf (stdout, "%f \n", (pow (2.0, (double) (sizeof(typett) 
            - 1) * 8.0)));

#endif  

  return 0;
}
